<?php
require_once '../core/loader_app.php';

class TallerMainHandler{

	protected $_command;
	protected $_response = array();
	protected $_data = array();
	protected $_user = array();

	function __construct(){
		$this->_response['status'] = false;
		$this->_response["msg"] = 'NO DATA';
	}

	public function executeCommand($command, $data = ''){
		$access = array();
		$this->_command = $command;
		$this->_data = $data;

		$this->getAccess();
		if( $this->_response['status'] ){
			$this->getCommand();
		}
		return $this->_response;
	}

	protected function getCommand(){
		switch ($this->_command) {

				case 'UsuariosTaller':
					$this->_response['status'] = false;
					$ft = $this->_data;
					$fl = array();					

					$fl = QB::table('users_programas')
								->select(array( 'users_programas.id', 'users.first_name', 'users.last_name', 'users.email', 'users_programas.asist' ))
								->join('users','users.id', '=', 'users_programas.user_id')
								->where('users_programas.programa_id', '=', $ft[1]['value'])
								->get();
					$this->_response['data'] = $fl;
					$this->_response['status'] = true;
				break;

				case 'ListaAdmin':
					$this->_response['status'] = false;
					$ft = $this->_data;
					$fl = array();

					switch ($ft) {
						case '22':
							$fl = QB::table('programa')
										->select(array('programa.id', 'programa.dia', 'programa.hora', 'talleres.nombre', 'programa.lugar'))
										->join('talleres','talleres.id', '=', 'programa.taller_id')
										->where('programa.dia', '=', '2014-10-22')
										->get();
							$this->_response['data'] = $fl;
							$this->_response['status'] = true;
						break;

						case '23':
							$fl = QB::table('programa')
										->select(array('programa.id', 'programa.dia', 'programa.hora', 'talleres.nombre', 'programa.lugar'))
										->join('talleres','talleres.id', '=', 'programa.taller_id')
										->where('programa.dia', '=', '2014-10-23')
										->get();
							$this->_response['data'] = $fl;
							$this->_response['status'] = true;
						break;

						case '24':
							$fl = QB::table('programa')
										->select(array('programa.id', 'programa.dia', 'programa.hora', 'talleres.nombre', 'programa.lugar'))
										->join('talleres','talleres.id', '=', 'programa.taller_id')
										->where('programa.dia', '=', '2014-10-24')
										->get();
							$this->_response['data'] = $fl;
							$this->_response['status'] = true;
						break;

						default:
							$this->_response['status'] = false;
							$this->_response['msg'] = 'Parametro Erroneo.';
						break;
					}
				break;

				case 'Lista':
					$this->_response['status'] = false;
					$data = array(
							'asist'	=> true
						);
					QB::table('users_programas')
							->where('id', '=', $this->_data)
							->update($data);
					$this->_response['status'] = true;
				break;

				case 'ListaQ':
					$this->_response['status'] = false;
					$data = array(
							'asist'	=> false
						);

					QB::table('users_programas')
							->where('id', '=', $this->_data)
							->update($data);
					$this->_response['status'] = true;
				break;

				case 'TallerLista':
					$this->_response['status'] = false;
					$ft = $this->_data;
					$fl = array();

					switch ($ft) {
						case '22':
							$fl = QB::table('programa')
										->select(array('programa.id', 'programa.dia', 'programa.hora', 'programa.maestro', 'programa.procedencia', 'programa.lugar', 'talleres.nombre', 'programa.curricular'))
										->join('talleres','talleres.id', '=', 'programa.taller_id')
										->where('dia', '=', '2014-10-22')
										->get();
							foreach ($fl as $kf => $vf) {
								$t = 0;
								$total = QB::table('users_programas')
											->where('programa_id', '=', $vf->id)
											->count();
								if($vf->curricular == true){
									$t = 30;
								} else {
									$t = 40;
								}
								if(Sentry::check()){
									$b = QB::table('users_programas')
												->where('programa_id', '=', $vf->id)
												->where('user_id', '=', Sentry::getUser()->id)
												->get();
									if($b){
										$vf->bool = true;	
									} else {
										$vf->bool = false;	
									}
									$this->_response['logueado'] = true;
								} else {
									$this->_response['logueado'] = false;
								}
								$vf->total = $t - $total;
								if($vf->total == 0){
									$vf->cupo = false;
								} else {
									$vf->cupo = true;
								}
							}
							$this->_response['data'] = $fl;
							$this->_response['status'] = true;
						break;

						case '23':
							$fl = QB::table('programa')
										->select(array('programa.id', 'programa.dia', 'programa.hora', 'programa.maestro', 'programa.procedencia', 'programa.lugar', 'talleres.nombre', 'programa.curricular'))
										->join('talleres','talleres.id', '=', 'programa.taller_id')
										->where('dia', '=', '2014-10-23')
										->get();
							foreach ($fl as $kf => $vf) {
								$t = 0;
								$total = QB::table('users_programas')
											->where('programa_id', '=', $vf->id)
											->count();
								if($vf->curricular == true){
									$t = 30;
								} else {
									$t = 40;
								}
								if(Sentry::check()){
									$b = QB::table('users_programas')
												->where('programa_id', '=', $vf->id)
												->where('user_id', '=', Sentry::getUser()->id)
												->get();
									if($b){
										$vf->bool = true;	
									} else {
										$vf->bool = false;	
									}
									$this->_response['logueado'] = true;
								} else {
									$this->_response['logueado'] = false;
								}
								$vf->total = $t - $total;
								if($vf->total == 0){
									$vf->cupo = false;
								} else {
									$vf->cupo = true;
								}
							}
							$this->_response['data'] = $fl;
							$this->_response['status'] = true;
						break;

						case '24':
							$fl = QB::table('programa')
										->select(array('programa.id', 'programa.dia', 'programa.hora', 'programa.maestro', 'programa.procedencia', 'programa.lugar', 'talleres.nombre', 'programa.curricular'))
										->join('talleres','talleres.id', '=', 'programa.taller_id')
										->where('dia', '=', '2014-10-24')
										->get();
							foreach ($fl as $kf => $vf) {
								$t = 0;
								$total = QB::table('users_programas')
											->where('programa_id', '=', $vf->id)
											->count();
								if($vf->curricular == true){
									$t = 30;
								} else {
									$t = 40;
								}
								if(Sentry::check()){
									$b = QB::table('users_programas')
												->where('programa_id', '=', $vf->id)
												->where('user_id', '=', Sentry::getUser()->id)
												->get();
									if($b){
										$vf->bool = true;	
									} else {
										$vf->bool = false;	
									}
									$this->_response['logueado'] = true;
								} else {
									$this->_response['logueado'] = false;
								}
								$vf->total = $t - $total;
								if($vf->total == 0){
									$vf->cupo = false;
								} else {
									$vf->cupo = true;
								}
							}
							$this->_response['data'] = $fl;
							$this->_response['status'] = true;
						break;

						default:
							$this->_response['status'] = false;
							$this->_response['msg'] = 'Parametro Erroneo.';
						break;
					}
				break;

				case 'AgregarTaller':
					$this->_response['status'] = false;
					$data = array(
							'programa_id'	=> $this->_data,
							'user_id'		=> Sentry::getUser()->id
						);
					$t = 0;
					$fl = QB::table('programa')
							->select(array('programa.curricular'))
							->where('id', '=', $this->_data)
							->first();
					if($fl->curricular == true){
						$t = 30;
					} else {
						$t = 40;
					}
					$total = QB::table('users_programas')
									->where('programa_id', '=', $this->_data)
									->count();
					$tf = (int)$t - (int)$total;
					if($tf > 0 && $tf <= $t){
						QB::table('users_programas')->insert($data);
						$this->_response['status'] = true;
						$this->_response['total'] = $tf-1;
					}
					
				break;
				case 'QuitarTaller':
					QB::table('users_programas')
							->where('programa_id', '=', $this->_data)
							->where('user_id', '=', Sentry::getUser()->id)
							->delete();
					$fl = QB::table('programa')
							->select(array('programa.curricular'))
							->where('id', '=', $this->_data)
							->first();
					if($fl->curricular == true){
						$t = 30;
					} else {
						$t = 40;
					}
					$total = QB::table('users_programas')
									->where('programa_id', '=', $this->_data)
									->count();
					$tf = (int)$t - (int)$total;
					$this->_response['status'] = true;
					$this->_response['total'] = $tf;
				break;
		}
	}

	protected function getAccess(){
		$this->_response['status'] = true;
	}

}// termina DataMainHandler
