<?php

class Users
{
	protected $_response;

	function __construct(){
		$this->_response['status'] = false;
		$this->_response["msj"] = 'NO DATA';
	}

	public function createUser($user_data){
		$this->_response['status'] = false;
		try{
		    $user = Sentry::createUser($user_data['user']);
		    $activationCode = $user->getActivationCode();
		    $group = Sentry::findGroupByName($user_data['group']['name']);

		    $user_data['user_data']['user_id'] = $user->id;
		    $id_exp = $user->id;
		    QB::table('user_data')->insert( $user_data['user_data'] );
    		
    		$user->addGroup($group);
    		$subject = 'Cuenta Expo Pyme Oaxaca 2014.';
    		$url = dirname(LINK_BASE);
    		$body = '
    		<html>
    		<meta charset="utf-8">
    		<head></head>
    			<body>
    				<p>A continuaci&oacute;n se te proporcionara el link con el codigo de activaci&oacute;n y tu contrase&ntilde;a para que puedas acceder a tu cuenta.</p>
    				<p>Correo Electronico: '.$user_data['user']['email'].'</p>
    				<p>contrase&ntilde;a: '.$user_data['user']['password'].'</p>
    			</body>
    		</html>';
    		$e = Customs::SendEmail( array($user_data['user']['email']), $subject, $body);
    		if($e){
	    		if($user_data['user_data']['status_active'] == 1){
					$data = array(
								'hash' 	=> $activationCode,
								'email' => $user_data['user']['email']
							);
	    			$r = $this->activateUser($data);
	    			if($r['status'] == true){
						$this->_response['status'] = true;
						$this->_response['msg'] = 'Usuario Creado y Activado Correcamente.';
						$this->_response['id'] = $id_exp;
	    			} else {
	    				$this->_response['msg'] = $r['msg'];
	    			}
	    		} else {
					$this->_response['status'] = true;
					$this->_response['msg'] = 'Usuario Creado Correcamente.';
					$this->_response['id'] = $id_exp;
	    		}

    		} else {
				try {
				    $user = Sentry::findUserById($user->id);
				    $user->delete();
				    QB::table('user_data')->where('user_id', '=', $user->id)->delete();
				    $this->_response['msg'] = 'Error al Intentar Crear el Usuario.';
				} catch (Cartalyst\Sentry\Users\UserNotFoundException $e) {
					$this->_response['msg'] = 'Usuario No Creado.';
				}
    		}
		} catch (Cartalyst\Sentry\Users\LoginRequiredException $e) {
			$this->_response['msg'] = 'Introduzca un Correo Electronico Valido.';
		} catch (Cartalyst\Sentry\Users\PasswordRequiredException $e) {
			$this->_response['msg'] = 'Introduzca una Contraseña Valida.';
		} catch (Cartalyst\Sentry\Users\UserExistsException $e) {
			$this->_response['msg'] = 'El Correo Electronico ya Existe en el Sistema.';
		} catch (Cartalyst\Sentry\Groups\GroupNotFoundException $e) {
			$this->_response['msg'] = 'El Grupo del Usuario no Existe.';
		}
		return $this->_response;
	}

	public function activateUser($data){
		$this->_response['status'] = false;
		try {
		    $user = Sentry::findUserByLogin($data['email']);
		    if ($user->attemptActivation($data['hash']) ){
				$this->_response['status'] = true;
				$this->_response['msg'] = 'Usuario Activado Exitósamente.';
			} else {
				$this->_response['msg'] = 'Error Activando al Usuario.';
		    }
		} catch (Cartalyst\Sentry\Users\UserNotFoundException $e) {
			$this->_response['msg'] = 'El Usuario NO Existe.';
		} catch (Cartalyst\Sentry\Users\UserAlreadyActivatedException $e) {
			$this->_response['msg'] = 'El Usuario ya se encuentra Activado.';
		}
		return $this->_response;
	}

	public function FindUserInGroup($g, $ta){
		$userArr = array();
		$group = Sentry::findGroupByName($g);
		$users = Sentry::findAllUsersInGroup($group);
		foreach ($users AS $u) array_push($userArr, $u->toArray());
		
		if($ta != 'user_data'){
			foreach ($userArr AS $k => $ua) {
				$ud = QB::table($ta)
						->where('user_id', '=', $ua['id'])
						->first();
				$userArr[$k]['asist_23'] = $ud->asist_23;
			}
		}

		$this->_response['data'] = $userArr;
		$this->_response['status'] = true;
		return $this->_response;
	}
}// termina Clients

?>