<?php
require_once '../core/loader_app.php';
require_once 'Users.class.php';

class ReportsMainHandler{

	protected $_command;
	protected $_response = array();
	protected $_data = array();
	protected $_user = array();
	protected $_users;

	function __construct(){
		$this->_response['status'] = false;
		$this->_response["msg"] = 'NO DATA';
		$this->_users = new Users();
		if(Sentry::check()){
			$this->_user = Sentry::getUser();
		}
	}

	public function executeCommand($command, $data = ''){
		$access = array();
		$this->_command = $command;
		$this->_data = $data;

		$this->getAccess();
		if( $this->_response['status'] ){
			$this->getCommand();
		}
		return $this->_response;
	}

	protected function getCommand(){
		switch ($this->_command) {

				case 'UsuarioRegistrados':
					$this->_response['status'] = false;
					$response_ajax = array();
					$fechas = array();
					$data = array();
					$fechas = QB::table('users')
									->select(QB::raw("DISTINCT(DATE(created_at)) AS fecha_registro"))
									->get();
					
					$grupos = array(
								array('ind' => 5, 'name' => 'Empresario'),
								array('ind' => 6, 'name' => 'Emprendedor'),
						);
					foreach ($grupos as $kg => $vg) {
						foreach ($fechas as $kf => $vf) {
							$q = QB::query('SELECT COUNT(users.created_at) AS total FROM users_groups
											JOIN users ON users.id = users_groups.user_id
											WHERE DATE(users.created_at) = ?
											AND  users_groups.group_id = ?', array($vf->fecha_registro, $vg['ind']) )
									->first();
							if($q){
								$total = $q->total;
							} else {
								$total = 0;
							}
							$data_construct = array(
												0 => strtotime($vf->fecha_registro)*1000,
												1 => $total
											);
							$data[$kg]['data'][$kf] = $data_construct;
						}
						$data[$kg]['label'] = $vg['name'];
					}
					if( !empty($data) ){
						$this->_response['status'] = true;
						$this->_response['data'] = $data;
					}
				break;

				default:
					$this->_response['msg'] = 'Comando Invalido.';
				break;
			}
	}

	protected function getAccess(){
		$this->_response['status'] = true;
	}

}// termina DataMainHandler
