<?php
require_once '../core/loader_app.php';
require_once 'Users.class.php';

class UsersMainHandler{

	protected $_command;
	protected $_response = array();
	protected $_data = array();
	protected $_users;
	protected $_user = array();

	function __construct(){
		$this->_response['status'] = false;
		$this->_response["msg"] = 'NO DATA';
		$this->_users = new Users();
		if(Sentry::check()){
			$this->_user = Sentry::getUser();
		}
	}

	public function executeCommand($command, $data = ''){
		$access = array();
		$this->_command = $command;
		$this->_data = $data;

		$this->getAccess();
		if( $this->_response['status'] ){
			$this->getCommand();
		}
		return $this->_response;
	}

	protected function getCommand(){
		switch ($this->_command) {

				case 'CreateUser':					
					if( $this->_response['status'] ){
						$this->_response['status'] = false;
						if( !empty($this->_data[0]['value']) && !empty($this->_data[1]['value']) && !empty($this->_data[2]['value']) ){
							if( Forms::ValidateEmail($this->_data[2]['value']) ){
								$user = array(
										'user' => array(
												'email' 		=> $this->_data[2]['value'],
												'password' 		=> 'Pyme2014',
												'first_name' 	=> $this->_data[0]['value'],
												'last_name' 	=> $this->_data[1]['value']
											),
										'user_data' => array(
												'user_id'		=> '',
												'img_perfil' 	=> 'logo.png',
												'status_active'			=> (integer)$this->_data[4]['value']
											),
										'group' => array(
												'name' 			=> $this->_data[3]['value']
											)
									);
								$r = $this->_users->createUser($user);
								if($r['status'] == true){
									$this->_response['status'] = true;
									$this->_response['msg'] = $r['msg'];
								} else {
									$this->_response['msg'] = $r['msg'];
								}
							} else {
								$this->_response['msg'] = 'Introduce un Correo Electronico Valido.';
							}
						} else {
							$this->_response['msg'] = 'Todos Los Campos Son Obligatorios.';
						}
					}
				break;

				case 'EditUser':
					$this->_response['status'] = false;
					if( !empty($this->_data['form'][0]['value']) && !empty($this->_data['form'][1]['value']) && !empty($this->_data['form'][2]['value']) ){
						try{
							$user = Sentry::findUserById($this->_data['user_id']);

	    					$user->first_name = $this->_data['form'][0]['value'];
	    					$user->last_name = $this->_data['form'][1]['value'];
	    					$user->email = $this->_data['form'][2]['value'];

						    if ($user->save()) {
						    	$this->_response['status'] = true;
						       $this->_response['msg'] = 'Usuario Actualizado.';
						    } else {
								$this->_response['msg'] = 'El Usuario no se pudo actualiza.';
						    }
						} catch (Cartalyst\Sentry\Users\UserNotFoundException $e) {
							$this->_response['msg'] = 'El Usuario No Existe.';
						} catch (Cartalyst\Sentry\Groups\GroupNotFoundException $e) {
							$this->_response['msg'] = 'El Grupo No Existe.';
						}
					} else {
						$this->_response['msg'] = 'El Formulario debe de estar Completo.';
					}
				break;

				case 'DeleteUser':
					$this->_response['status'] = false;
					try {
					    $user = Sentry::findUserById($this->_data);
					    $ud = false;
						if ($user->inGroup( Sentry::findGroupByName('Emprendedores') )){
							QB::table('emp_data')->where('user_id', '=', $this->_data)->delete();	
						} else {
							$ud = true;
						}
						if ($user->inGroup( Sentry::findGroupByName('Empresarios') )){
							QB::table('empresa_data')->where('user_id', '=', $this->_data)->delete();	
						} else {
							$ud = true;
						}
					    $user->delete();
					    if($ud == true){
							QB::table('user_data')->where('user_id', '=', $this->_data)->delete();
					    }
						
				    	$this->_response['status'] = true;
						$this->_response['msg'] = 'Usuario Eliminado Correctamente.';
					} catch (Cartalyst\Sentry\Users\UserNotFoundException $e) {
					    $this->_response['msg'] = 'El Usuario no Existe.';
					}
				break;
				
				case 'GetUserByID':
					$this->_response['status'] = false;
					try {
						$user = array();
					    $user = QB::query('SELECT G.id AS group_id, G.name AS group_name, U.email, U.first_name, U.last_name FROM users_groups UG 
												JOIN users U ON U.id = UG.user_id
												JOIN groups G ON G.id = UG.group_id
												WHERE UG.user_id = ?', array($this->_data))
					    			->first();

					    $this->_response['status'] = true;
					    $this->_response['data'] = $user;
					} catch (Cartalyst\Sentry\Users\UserNotFoundException $e) {
					    $this->_response['msg'] = 'El Usuario no Existe.';
					}
				break;

				case 'A':
					$this->_response['status'] = false;
					$user = $this->_users->FindUserInGroup('root', 'user_data');
					if( !empty($user['data']) ){
						$user3 = Sentry::getUser();
						$admin = Sentry::findGroupByName('root');
						$this->_response['edit'] = false;
						if( $user3->inGroup($admin) ){
							$this->_response['edit'] = true;
						}
						$this->_response['status'] = true;
						$this->_response['data'] = $user['data'];
						$this->_response['group'] = 'Administrador';
						$this->_response['letter'] = 'A';
						$this->_response['msg'] = 'Administradores Encontrados.';
					} else {
						$this->_response['msg'] = 'No se Encontraron Administradores.';
					}
				break;

				case 'AS':
					$this->_response['status'] = false;
					$user = $this->_users->FindUserInGroup('Asistente', 'user_data');
					if( !empty($user['data']) ){
						$user3 = Sentry::getUser();
						$admin = Sentry::findGroupByName('root');
						$this->_response['edit'] = false;
						if( $user3->inGroup($admin) ){
							$this->_response['edit'] = true;
						}
						$this->_response['status'] = true;
						$this->_response['data'] = $user['data'];
						$this->_response['group'] = 'Asistente';
						$this->_response['letter'] = 'AS';
						$this->_response['msg'] = 'Asistentes Encontrados.';
					} else {
						$this->_response['msg'] = 'No se Encontraron Asistentes.';
					}
				break;

				case 'ED':
					$this->_response['status'] = false;
					$user = $this->_users->FindUserInGroup('Emprendedores', 'emp_data');
					if( !empty($user['data']) ){
						$user3 = Sentry::getUser();
						$admin = Sentry::findGroupByName('root');
						$this->_response['edit'] = false;
						if( $user3->inGroup($admin) ){
							$this->_response['edit'] = true;
						}
						$this->_response['status'] = true;
						$this->_response['data'] = $user['data'];
						$this->_response['group'] = 'Emprendedores';
						$this->_response['letter'] = 'ED';
						$this->_response['msg'] = 'Emprendedores Encontrados.';
					} else {
						$this->_response['msg'] = 'No se Encontraron Emprendedores.';
					}
				break;

				case 'ES':
					$this->_response['status'] = false;
					$user = $this->_users->FindUserInGroup('Empresarios', 'empresa_data');
					if( !empty($user['data']) ){
						$user3 = Sentry::getUser();
						$admin = Sentry::findGroupByName('root');
						$this->_response['edit'] = false;
						if( $user3->inGroup($admin) ){
							$this->_response['edit'] = true;
						}
						$this->_response['status'] = true;
						$this->_response['data'] = $user['data'];
						$this->_response['group'] = 'Empresarios';
						$this->_response['letter'] = 'ES';
						$this->_response['msg'] = 'Empresarios Encontrados.';
					} else {
						$this->_response['msg'] = 'No se Encontraron Empresarios.';
					}
				break;

				case 'ActivateUser':
					$this->_response['status'] = false;  
					try {
					    $user = Sentry::findUserById($this->_data);
					    $activationCode = $user->getActivationCode();
					    if ($user->attemptActivation($activationCode)){
					    	$this->_response['status'] = true;    
					    	$this->_response['msg'] = 'Usuario Activado.';
					    } else {
					    	$this->_response['msg'] = 'No se pudo Activar al Usuario.';    
					    }
					} catch (Cartalyst\Sentry\Users\UserNotFoundException $e) {
						$this->_response['msg'] = 'El Usuario no Existe.';
					} catch (Cartalyst\Sentry\Users\UserAlreadyActivatedException $e) {
						$this->_response['msg'] = 'El Usuario ya esta Activado.';
					}
				break;

				case 'DesactivateUser':
					$this->_response['status'] = false;
					$data = array(
    							'activated' => false,
							);
					QB::table('users')->where('id', '=', $this->_data)->update($data);
					$this->_response['status'] = true;
					$this->_response['msg'] = 'El Usuario ha sido Desactivado.';

				break;

				case 'Lista':
					$this->_response['status'] = false;
					$data = array(
							'user_id'	=> $this->_data['id'],
							'asist_23'	=> true
						);
					switch ($this->_data['tipo']) {
						case 'ED':
							QB::table('emp_data')
									->where('user_id', '=', $this->_data['id'])
									->update($data);
							$this->_response['status'] = true;
						break;
						case 'ES':
							QB::table('empresa_data')
									->where('user_id', '=', $this->_data['id'])
									->update($data);
							$this->_response['status'] = true;
						break;
					}
				break;

				case 'ListaQ':
					$this->_response['status'] = false;
					$data = array(
							'user_id'	=> $this->_data['id'],
							'asist_23'	=> false
						);
					switch ($this->_data['tipo']) {
						case 'ED':
							QB::table('emp_data')
									->where('user_id', '=', $this->_data['id'])
									->update($data);
							$this->_response['status'] = true;
						break;
						case 'ES':
							QB::table('empresa_data')
									->where('user_id', '=', $this->_data['id'])
									->update($data);
							$this->_response['status'] = true;
						break;
					}
				break;

				case 'LiveSearch':
					$this->_response['status'] = false;
					$rt = array();
					switch ($this->_data['letter']) {
						case 'ED':
							$rt = QB::query('SELECT UG.user_id AS id, U.first_name, U.last_name, U.email, U.activated FROM users_groups UG
												JOIN users U ON U.id = UG.user_id
												JOIN groups G ON G.id = UG.group_id
												WHERE UG.user_id = ?
												AND UG.group_id = 6', array($this->_data['id']) )->get();
							foreach ($rt as $k => $v) {
								$r = QB::table('emp_data')
										->where('user_id', '=', $v->id)
										->first();
								$v->asist_23 = $r->asist_23;
							}
							$user3 = Sentry::getUser();
							$admin = Sentry::findGroupByName('root');
							$this->_response['edit'] = false;
							if( $user3->inGroup($admin) ){
								$this->_response['edit'] = true;
							}
							$this->_response['group'] = 'Emprendedores';
							$this->_response['letter'] = 'ED';
						break;
						case 'ES':
							$rt = QB::query('SELECT UG.user_id AS id, U.first_name, U.last_name, U.email, U.activated FROM users_groups UG
										JOIN users U ON U.id = UG.user_id
										JOIN groups G ON G.id = UG.group_id
										WHERE UG.user_id = ?
										AND UG.group_id = 5', array($this->_data['id']) )->get();
							foreach ($rt as $k => $v) {
								$r = QB::table('empresa_data')
									->where('user_id', '=', $v->id)
									->first();
								$v->asist_23 = $r->asist_23;

							}
							$user3 = Sentry::getUser();
							$admin = Sentry::findGroupByName('root');
							$this->_response['edit'] = false;
							if( $user3->inGroup($admin) ){
								$this->_response['edit'] = true;
							}
							$this->_response['group'] = 'Empresarios';
							$this->_response['letter'] = 'ES';
						break;
					}
					if($rt){
						$this->_response['status'] = true;
						$this->_response['data'] = $rt;
					} else {
						$this->_response['msg'] = 'No hay usuario con este gafete.';
					}
				break;

				case 'LiveSearchName':
					$this->_response['status'] = false;
					$rt = array();
					switch ($this->_data['letter']) {
						case 'ED':
							$rt = QB::query('SELECT UG.user_id AS id, U.first_name, U.last_name, U.email, U.activated FROM users_groups UG
												JOIN users U ON U.id = UG.user_id
												JOIN groups G ON G.id = UG.group_id
												WHERE U.first_name LIKE "%'.$this->_data['name'].'%"
												AND UG.group_id = 6')->get();
							foreach ($rt as $k => $v) {
								$r = QB::table('emp_data')
										->where('user_id', '=', $v->id)
										->first();
								$v->asist_23 = $r->asist_23;
							}
							$user3 = Sentry::getUser();
							$admin = Sentry::findGroupByName('root');
							$this->_response['edit'] = false;
							if( $user3->inGroup($admin) ){
								$this->_response['edit'] = true;
							}
							$this->_response['group'] = 'Emprendedores';
							$this->_response['letter'] = 'ED';
						break;
						case 'ES':
							$rt = QB::query('SELECT UG.user_id AS id, U.first_name, U.last_name, U.email, U.activated FROM users_groups UG
										JOIN users U ON U.id = UG.user_id
										JOIN groups G ON G.id = UG.group_id
										WHERE U.first_name LIKE %'.$this->_data['name'].'%
										AND UG.group_id = 5' )->get();
							foreach ($rt as $k => $v) {
								$r = QB::table('empresa_data')
									->where('user_id', '=', $v->id)
									->first();
								$v->asist_23 = $r->asist_23;

							}
							$user3 = Sentry::getUser();
							$admin = Sentry::findGroupByName('root');
							$this->_response['edit'] = false;
							if( $user3->inGroup($admin) ){
								$this->_response['edit'] = true;
							}
							$this->_response['group'] = 'Empresarios';
							$this->_response['letter'] = 'ES';
						break;
					}
					if($rt){
						$this->_response['status'] = true;
						$this->_response['data'] = $rt;
					} else {
						$this->_response['msg'] = 'No hay usuario con este nombre.';
					}
				break;

				case 'TotalUsers':
					$this->_response['status'] = false;
					$ut = QB::query('SELECT users_groups.user_id FROM users_groups 
										JOIN users ON users.id =  users_groups.user_id
										WHERE group_id = 5 or group_id = 6 or group_id = 7')
								->get();
					if($ut){
						$this->_response['status'] = true;
						$this->_response['data'] = count($ut);
					} else {
						$this->_response['data'] = 0;
					}
				break;

				default:
					$this->_response['msg'] = 'Comando Invalido.';
				break;
			}
	}

	protected function getAccess(){
		$this->_response['status'] = true;
	}

}// termina DataMainHandler